/*------------------------------------------------------------------------------
--  This file is a part of the libuc, microcontroler library
--  Copyright (C) 2012, Alexis Jeandet
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------
--                 Author : Alexis Jeandet
--                   Mail : alexis.jeandet@gmail.com
-------------------------------------------------------------------------------*/
#ifndef GENERICLCD_CONTROLER_H
#define GENERICLCD_CONTROLER_H

#include <uhandle.h>
#include <fonts.h>


typedef struct LCD_IF_t
{
    int (*init)();
    void (*writereg)(uint32_t reg,uint32_t data);
    uint32_t (*readreg)(uint32_t reg);
    void (*writeGRAM)(void* buffer,uint32_t count);
    void (*readGRAM)(void* buffer,uint32_t count);
}LCD_IF_t;

typedef struct LCD_t
{
    LCD_IF_t* interface;
    int (*init)(struct LCD_t* LCD);
    void (*paint)(struct LCD_t* LCD,void* buffer,uint16_t Xpos,uint16_t Ypos,uint16_t Width,uint16_t Height);
    void (*paintText)(struct LCD_t* LCD,char* buffer,uint16_t Xpos,uint16_t Ypos,sFONT *font,uint32_t color);
    void (*paintFilRect)(struct LCD_t* LCD,uint16_t Xpos,uint16_t Ypos,uint16_t w,uint16_t h,uint32_t contColor,uint16_t contSz,uint32_t fillColor);
    void (*getPix)(struct LCD_t* LCD,uint16_t* buffer,uint16_t Xpos,uint16_t Ypos,uint16_t w,uint16_t h);
    void (*refreshenable)(struct LCD_t* LCD,int enable);
    uint16_t width;
    uint16_t height;
}LCD_t;


#endif              /*GENERICLCD_CONTROLER_H*/





